<?php
/*!! Structure.Extension.BackupManager:
   .
*/
class Service_BackupManager extends XcBase {

    var $_kernel;

    function Service_BackupManager($kernelLink) {
           $this->_localname = 'BackupManager';
           $this->XcBase($kernelLink);
           $this->_kernel = $this->srvMainKernel();
           //$this->advOnto = $this->_kernel->srvFactory("AdvOntology");
    }

    function onInstall($params) {

       return true;
    }

    function onUninstall($params) {

          return true;
    }

    function getBackupFilePath() {
           global $crossSiteName;

           return $this->_kernel->getRootPath()."sites/".$crossSiteName."/data/BackupManager/backups/";
    }

    function makeTableBackup($tablename, $fp) {
        $createTable = $this->_db->LoadSingle('SHOW CREATE TABLE `'.$tablename.'`');

        $createCode = str_replace("\n","",str_replace("\r","",$createTable['Create Table']));

        $tableDump = "DROP TABLE IF EXISTS `$tablename`;\n" . $createCode . ";\n\n";

        $this->writeFileData($fp, $tableDump);

        $res = $this->_db->LoadAll("SELECT * FROM ".$tablename);

        foreach($res as $rec) {
           //$tableDump .= 'INSERT INTO '.$tablename.' SET '.$this->_db->dbConstructSetArray($rec).";\n";
           $this->writeFileData($fp, 'INSERT INTO '.$tablename.' SET '.$this->_db->dbConstructSetArray($rec).";\n");
        }

        $this->writeFileData($fp, "\n\n");

        return $tableDump;
    }

    function makeFullDbBackup($desc) {
        /*
        $today = date("Y-m-d H-i-s");
        $filename = $this->getBackupFilePath()."backup ".$today." ".$desc;
        $fp = $this->openFileWrite($filename,"w");
        */
        $tableList = $this->getTableList();
        $this->makeSomeDbBackup($tableList, $desc);
        /*
        foreach($tableList as $tableName) {
           $tdump = $this->makeTableBackup($tableName, $fp);
           //fwrite($fp, $tdump);
        }


        $this->closeFile($fp);
        @chmod($filename, 0777);
        */
    }

    function makeSomeDbBackup($tableList, $desc) {
         $today = date("Y-m-d H-i-s");
        $filename = $this->getBackupFilePath()."backup ".$today." ".$desc;
        $fp = $this->openFileWrite($filename);

        foreach($tableList as $tableName) {
           $tdump = $this->makeTableBackup($tableName, $fp);
           //fwrite($fp, $tdump);
        }

        $this->closeFile($fp);
        @$this->chmodFile($filename, 0777);
    }

    function getTableList() {
       $tlist = $this->_db->LoadAll("SHOW TABLES LIKE '".$this->_db->config["table_prefix"]."%'");
       $res = array();
       foreach($tlist as $table) {
         foreach($table as $value) {
           $res[] = $value;
         }
       }
       return $res;
    }

    function cron_MakeFullDBBackup($params) {
       //echo "BackupManger running!";
       @set_time_limit(0);
       $this->makeFullDbBackup("by cron");
    }

    function cron_RestoreBackupSQL($params) {
       //echo "BackupManger running!";
       @set_time_limit(0);
       $filepath = $this->getBackupFilePath()."backup.sql";
       if(file_exists($filepath)) {
                $filecont = file_get_contents($filepath);
                $filecont = str_replace("\r","",$filecont);
                $filearr = explode("\n",$filecont);
                //echo htmlspecialchars($filecont);
                foreach($filearr as $query) {
                  if($query!="") {
                     if(strstr($query,'--')!=$query) {
                        $this->_db->Query($query);
                        //echo htmlspecialchars($query)."<br />";
                     }
                  }
                }
                //echo "<b>   !</b>";
        }
    }

    function cron_RestoreBackupSQLAndUserFiles($params) {
       $this->cron_RestoreBackupSQL($params);
       $kernel = $this->_kernel;
       global $crossSiteName;
       $targetdir = $kernel->getRootPath()."sites/".$crossSiteName."/data/XmUserFiles";
       $this->remove_u($targetdir.'/userfiles');

       require ($kernel->getRootPath().'lib/archive/ArchiveExtractor.class.php');
       $archExtractor=new ArchiveExtractor();
       if(file_exists($targetdir."/userfiles.zip")) {
          $arFile = $targetdir."/userfiles.zip";
       }
       if(file_exists($targetdir."/userfiles.tgz")) {
          $arFile = $targetdir."/userfiles.tgz";
       }
       $extractedFileList = $archExtractor->extractArchive($arFile,$targetdir."/");

       echo $targetdir."\n--------------------\n";
       //print_r($extractedFileList);
    }

    function remove_u($dir)
    {
        if(is_file($dir)) {
           return unlink($dir);
           /*
           echo $dir."\n";
           return;
           */
        }

        $dh=opendir($dir);
        while(false!==($file=readdir($dh)))
        {
                if($file=='.'||$file=='..') continue;
                $this->remove_u($dir."/".$file);
        }
        closedir($dh);

        //echo $dir."\n";
        return rmdir($dir);
    }

    function chmodFile($filename, $prava) {
       if(function_exists('gzopen')) {
         $filename .= '.gz';
       }
       chmod($filename, $prava);
    }

       function openFileWrite($filename)
       {
         if(function_exists('gzopen'))
         {
           $filename .= '.gz';
           $handle = gzopen($filename, "w9");
         }
         else
         {
           $handle = fopen($filename, "w");
         }
         return $handle;
       }

       function openFileRead($filename)
       {
         if(function_exists('gzopen'))
         {
           $handle = gzopen($filename, "r");
         }
         else
         {
           $handle = fopen($filename, "r");
         }
         return $handle;
       }

       function writeFileData($handle, $data)
       {
         if(function_exists('gzwrite'))
         {
           gzwrite($handle, $data);
         }
         else
         {
           fwrite($handle, $data);
         }
       }

       function readFileData($handle, $size)
       {
         if(function_exists('gzread'))
         {
           $data = gzread($handle, $size);
         }
         else
         {
           $data = fread($handle, $size);
         }
         return $data;
       }

       function eof($handle)
       {
         if(function_exists('gzeof'))
         {
           return gzeof($handle);
         }
         else
         {
           return feof($handle);
         }
       }

       function closeFile($handle)
       {
         if(function_exists('gzclose'))
         {
           gzclose($handle);
         }
         else
         {
           fclose($handle);
         }
       }


}

?>